
const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');



const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class TranscriptsDBApi {
    

    
    static async create(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const transcripts = await db.transcripts.create(
            {
                id: data.id || undefined,
        
        transcript_status: data.transcript_status
        ||
        null
            ,
            
        language_code: data.language_code
        ||
        null
            ,
            
        content: data.content
        ||
        null
            ,
            
        generated_at: data.generated_at
        ||
        null
            ,
            
        opt_in: data.opt_in
        ||
        false
        
            ,
            
            importHash: data.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
    },
        { transaction },
    );

        
        await transcripts.setConference( data.conference || null, {
            transaction,
        });
        
        await transcripts.setOrganizations( data.organizations || null, {
            transaction,
        });
        

        

        

        return transcripts;
    }
    

    static async bulkImport(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        // Prepare data - wrapping individual data transformations in a map() method
        const transcriptsData = data.map((item, index) => ({
                id: item.id || undefined,
                
                transcript_status: item.transcript_status
            ||
            null
            ,
            
                language_code: item.language_code
            ||
            null
            ,
            
                content: item.content
            ||
            null
            ,
            
                generated_at: item.generated_at
            ||
            null
            ,
            
                opt_in: item.opt_in
            ||
            false
        
            ,
            
            importHash: item.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
            createdAt: new Date(Date.now() + index * 1000),
    }));

        // Bulk create items
        const transcripts = await db.transcripts.bulkCreate(transcriptsData, { transaction });

        // For each item created, replace relation files
        

        return transcripts;
    }

    static async update(id, data,  options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;
        const globalAccess = currentUser.app_role?.globalAccess;

        const transcripts = await db.transcripts.findByPk(id, {}, {transaction});


        

        const updatePayload = {};
        
        if (data.transcript_status !== undefined) updatePayload.transcript_status = data.transcript_status;
        
        
        if (data.language_code !== undefined) updatePayload.language_code = data.language_code;
        
        
        if (data.content !== undefined) updatePayload.content = data.content;
        
        
        if (data.generated_at !== undefined) updatePayload.generated_at = data.generated_at;
        
        
        if (data.opt_in !== undefined) updatePayload.opt_in = data.opt_in;
        
        
        updatePayload.updatedById = currentUser.id;

        await transcripts.update(updatePayload, {transaction});

        
        
        if (data.conference !== undefined) {
            await transcripts.setConference(
              
              data.conference,
              
              { transaction }
            );
        }
        
        if (data.organizations !== undefined) {
            await transcripts.setOrganizations(
              
              data.organizations,
              
              { transaction }
            );
        }
        

        
        

        

        return transcripts;
    }

    static async deleteByIds(ids, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const transcripts = await db.transcripts.findAll({
            where: {
                id: {
                    [Op.in]: ids,
                },
            },
            transaction,
        });

        await db.sequelize.transaction(async (transaction) => {
            for (const record of transcripts) {
                await record.update(
                    {deletedBy: currentUser.id},
                    {transaction}
                );
            }
            for (const record of transcripts) {
                await record.destroy({transaction});
            }
        });


        return transcripts;
    }

    static async remove(id, options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;

        const transcripts = await db.transcripts.findByPk(id, options);

        await transcripts.update({
            deletedBy: currentUser.id
        }, {
            transaction,
        });

        await transcripts.destroy({
            transaction
        });

        return transcripts;
    }

    static async findBy(where, options) {
        const transaction = (options && options.transaction) || undefined;

        const transcripts = await db.transcripts.findOne(
            { where },
            { transaction },
        );

        if (!transcripts) {
            return transcripts;
        }

        const output = transcripts.get({plain: true});

        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        output.conference = await transcripts.getConference({
            transaction
        });
        
        
        output.organizations = await transcripts.getOrganizations({
            transaction
        });
        
        

        return output;
    }

    static async findAll(
          filter,
           globalAccess,  options
        ) {
        const limit = filter.limit || 0;
        let offset = 0;
        let where = {};
        const currentPage = +filter.page;

        
        const user = (options && options.currentUser) || null;
        const userOrganizations = (user && user.organizations?.id) || null;
        

        
        if (userOrganizations) {
            if (options?.currentUser?.organizationsId) {
                where.organizationsId = options.currentUser.organizationsId;
            }
        }
        

        offset = currentPage * limit;

        const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [

      {
        model: db.conferences,
        as: 'conference',
        
        where: filter.conference ? {
          [Op.or]: [
            { id: { [Op.in]: filter.conference.split('|').map(term => Utils.uuid(term)) } },
            {
              conference_key: {
                [Op.or]: filter.conference.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.organizations,
        as: 'organizations',
        
      },



    ];

        if (filter) {
            if (filter.id) {
                where = {
                    ...where,
                    ['id']: Utils.uuid(filter.id),
                };
            }

            
            if (filter.language_code) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'transcripts',
                        'language_code',
                        filter.language_code,
                    ),
                };
            }
            
            if (filter.content) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'transcripts',
                        'content',
                        filter.content,
                    ),
                };
            }
            

            
            

            
            if (filter.generated_atRange) {
                const [start, end] = filter.generated_atRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    generated_at: {
                    ...where.generated_at,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    generated_at: {
                    ...where.generated_at,
                            [Op.lte]: end,
                    },
                };
                }
            }
            

            if (filter.active !== undefined) {
                where = {
                    ...where,
                    active: filter.active === true || filter.active === 'true'
                };
            }

            
            if (filter.transcript_status) {
                where = {
                    ...where,
                transcript_status: filter.transcript_status,
            };
            }
            
            if (filter.opt_in) {
                where = {
                    ...where,
                opt_in: filter.opt_in,
            };
            }
            


      

      
      if (filter.organizations) {
        const listItems = filter.organizations.split('|').map(item => {
          return  Utils.uuid(item)
        });

        where = {
          ...where,
          organizationsId: {[Op.or]: listItems}
        };
      }
      



            if (filter.createdAtRange) {
                const [start, end] = filter.createdAtRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.gte]: start,
                        },
                    };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.lte]: end,
                        },
                    };
                }
            }
        }
        

        
        if (globalAccess) {
            delete where.organizationsId;
        }
        

        const queryOptions = {
            where,
            include,
            distinct: true,
            order: filter.field && filter.sort
                ? [[filter.field, filter.sort]]
                : [['createdAt', 'desc']],
            transaction: options?.transaction,
            logging: console.log
        };

        if (!options?.countOnly) {
            queryOptions.limit = limit ? Number(limit) : undefined;
            queryOptions.offset = offset ? Number(offset) : undefined;
        }

        try {
            const { rows, count } = await db.transcripts.findAndCountAll(queryOptions);

            return {
                rows: options?.countOnly ? [] : rows,
                count: count
            };
        } catch (error) {
            console.error('Error executing query:', error);
            throw error;
        }
    }

    static async findAllAutocomplete(query, limit, offset,  globalAccess, organizationId,) {
        let where = {};
        
        
        if (!globalAccess && organizationId) {
            where.organizationId = organizationId;
        }
        

        if (query) {
            where = {
                [Op.or]: [
                    { ['id']: Utils.uuid(query) },
                    Utils.ilike(
                        'transcripts',
                        'language_code',
                        query,
                    ),
                ],
            };
        }

        const records = await db.transcripts.findAll({
            attributes: [ 'id', 'language_code' ],
            where,
            limit: limit ? Number(limit) : undefined,
            offset: offset ? Number(offset) : undefined,
            orderBy: [['language_code', 'ASC']],
        });

        return records.map((record) => ({
            id: record.id,
            label: record.language_code,
        }));
    }

    
};

